//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include "mainform.h"
#include "net.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFmainform *Fmainform;

SOCKET pvksock;
SOCKADDR_IN pvkaddr;
#define UDP_PORT_PVK 2345

//---------------------------------------------------------------------------
__fastcall TFmainform::TFmainform(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::FormCreate(TObject *Sender)
{
/*
  AllocConsole();
  freopen("CONOUT$", "w", stdout);
  freopen("CONOUT$", "w", stderr);
  freopen("CONIN$", "r", stdin);
*/

  //initialize windows sockets
  WORD wVersionRequested;
  WSADATA wsaData;

  wVersionRequested=MAKEWORD(2,0);
  int result=WSAStartup( wVersionRequested, &wsaData );

  if (LOBYTE(wsaData.wVersion)!=2 || HIBYTE(wsaData.wVersion)!=0)
  {
    WSACleanup();
    Application->MessageBox("Winsock init failed", "Network error", MB_OK|MB_ICONSTOP);
    Application->Terminate();
  }

  pvksock=udpsocket();
  pvkaddr.sin_family=AF_INET;
  pvkaddr.sin_addr.s_addr=inet_addr("0.0.0.0");
  pvkaddr.sin_port=htons(UDP_PORT_PVK);
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::FormDestroy(TObject *Sender)
{
  closesocket(pvksock);
  WSACleanup();
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::SBconnectClick(TObject *Sender)
{
  hostent *he;

  if (((TSpeedButton *)Sender)->Down) {
    pvkaddr.sin_addr.s_addr=inet_addr(Eaddr->Text.c_str());
    if (pvkaddr.sin_addr.s_addr==INADDR_NONE) {
      he=gethostbyname(Eaddr->Text.c_str());
      if (he==NULL || he->h_addr_list[0]==NULL) {
        ((TSpeedButton *)Sender)->Down=false;
        Application->MessageBox("Cannot resolve host", "Network error", MB_OK|MB_ICONSTOP);
        return;
      }
      pvkaddr.sin_addr.s_addr=*((unsigned long *)he->h_addr_list[0]);
    }
    Trefresh->Enabled=true;
    Eaddr->Enabled=false;
  }
  else {
    Trefresh->Enabled=false;
    Eaddr->Enabled=true;
    LEDtx->Brush->Color=clMaroon;
    LEDrx->Brush->Color=clGreen;
  }
}
//---------------------------------------------------------------------------

TColor bulb_color(unsigned char bright)
{
  return (TColor)RGB(100+150*bright/100, 100+150*bright/100, 0+100*bright/100);
}

const unsigned char disp_num[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f};
const unsigned char disp_char[]=
  {/* A */ 0x77,0x7c,0x39,0x5e,0x79,0x71,
   /* G */ 0x3d,0x74,0x30,0x1e,0x00,0x38,
   /* M */ 0x37,0x54,0x5c,0x73,0x00,0x50,
   /* S */ 0x6d,0x78,0x3e,0x1c,0x00,0x00,
   /* Y */ 0x6e,0x5b
  };

#define DISP_DASH 0x40
#define DISP_UNDERSCORE 0x08
#define DISP_SPACE 0x00

void __fastcall TFmainform::TrefreshTimer(TObject *Sender)
{
  struct buff_out {
    unsigned char bargraph;
    unsigned char display[4];
  } buff_out;

  struct buff_in {
    WORD temp;
    WORD photo;
    WORD trim1;
    WORD trim2;
    BYTE buttons;
  } buff_in;

  int received;
  int i;
  int c;

  ((TTimer *)Sender)->Interval=500;

  buff_out.bargraph=TBbargraph->Max-TBbargraph->Position;
  for (i=0; i<4; i++) {
    c=Edisplay->Text[i+1];
    if (isalpha(c)) buff_out.display[i]=disp_char[c-'A'];
    else if (isdigit(c)) buff_out.display[i]=disp_num[c-'0'];
    else if (c=='-') buff_out.display[i]=DISP_DASH;
    else if (c=='_') buff_out.display[i]=DISP_UNDERSCORE;
    else buff_out.display[i]=DISP_SPACE;
  }

  LEDtx->Brush->Color=clRed;
  received=udptransact(pvksock,&pvkaddr,(char *)&buff_out,sizeof(buff_out),(char *)&buff_in,sizeof(buff_in));

  if (received>=9) {
    LEDrx->Brush->Color=clLime;
    Ltemp->Caption=AnsiString().sprintf("%.1fC",(float)((buff_in.temp>>6)-462)/2);

    Photo->Brush->Color=bulb_color(buff_in.photo*100/0xffc0);

    ProgressBar1->Position=buff_in.trim1*100/0xffc0;
    Ltrim1->Caption=AnsiString().sprintf("%u%%",buff_in.trim1*100/0xffc0);

    ProgressBar2->Position=buff_in.trim2*100/0xffc0;
    Ltrim2->Caption=AnsiString().sprintf("%u%%",buff_in.trim2*100/0xffc0);

    for (i=0; i<8; i++) {
      if (buff_in.buttons&(1<<i))
        PVKkeypad->Buttons[i]->Down=true;
      else PVKkeypad->Buttons[i]->Down=false;
    }
  }
  else {
    LEDrx->Brush->Color=clGreen;
  }
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::FormShow(TObject *Sender)
{
  Photo->Brush->Color=bulb_color(0);
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::EdisplayKeyPress(TObject *Sender, char &Key)
{
  AnsiString edittext;

  if (isalnum(Key) || Key==' ' || Key=='-' || Key=='_') {

    if (isalpha(Key) && !disp_char[toupper(Key)-'A']);
    else {
      edittext=((TEdit *)Sender)->Text;
      edittext.Delete(1,1);
      edittext+=(char)toupper(Key);
      ((TEdit *)Sender)->Text=edittext;
    }
  }
  ((TEdit *)Sender)->SelStart=4;
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::EdisplayClick(TObject *Sender)
{
  ((TEdit *)Sender)->SelStart=4;        
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::EdisplayChange(TObject *Sender)
{
  Trefresh->Interval=50;
}
//---------------------------------------------------------------------------

void __fastcall TFmainform::TBbargraphChange(TObject *Sender)
{
  Trefresh->Interval=50;
}
//---------------------------------------------------------------------------


