#include <stdio.h>
#include <string.h>

#include "eth.h"
#include "arp.h"
#include "ip.h"


unsigned char mymac[6];

struct eth_header ethh;


/* ethernet polling entry point */
void eth_proc(void)
{
  unsigned int len;

  if (len=nic_rx()) {

    if (len<sizeof(struct eth_header)) {
      nic_rx_free();
      return;
    }

    netbuf_read(&ethh, sizeof(struct eth_header));
    len-=sizeof(struct eth_header);
    switch (ethh.typelen) {
      case HTONS(ETHTYPE_ARP):
        arp_in(len);
        break;
      case HTONS(ETHTYPE_IP):
        ip_in(len);
        break;
    }
    nic_rx_free();
    
  }
}


/* ethernet packet transmission */
void eth_out(BYTE desta[], WORD type, unsigned int txbuf, unsigned int len)
{
  if (desta==NULL) {
    /* no destination address specified, send it as reply */
    memmove(ethh.desta, ethh.sourcea, 6);
  }
  else if (desta==ETH_BROADCAST) {
    /* or send generate special broadcast address */
    memset(ethh.desta, 0xff, 6);
  }
  else {
    /* otherwise use the address given as parameter */
    memmove(ethh.desta, desta, 6);
  }

  memmove(ethh.sourcea, mymac, 6);
  ethh.typelen=type;

  netbuf_wr_seek(txbuf, NB_SEEK_SET);
  netbuf_write((void*)&ethh, sizeof(struct eth_header));
  netbuf_close();
  
  nic_tx(len+sizeof(struct eth_header));
}
