#include "icmp.h"
#include "ip.h"
#include "eth.h"


void icmp_in(struct ip_header *iph, unsigned int len)
{
  struct icmp_header icmph;
  unsigned int txbuf;

  if (len<sizeof(struct icmp_header)) return;
  netbuf_read(&icmph, sizeof(struct icmp_header));

  switch (icmph.type) {
    case ICMP_ECHO:
      icmph.type=ICMP_REPLY; /* change type to reply */

      /* adjust the checksum accordingly */
      icmph.checksum+=HTONS(ICMP_ECHO<<8);
      if (icmph.checksum<HTONS(ICMP_ECHO<<8)) icmph.checksum++;

      if (!nic_tx_alloc(&txbuf)) return;
      netbuf_wr_seek(txbuf+IP_RESERVED, NB_SEEK_SET);
      netbuf_write(&icmph, sizeof(struct icmp_header));
      netbuf_copy(len-sizeof(struct icmp_header));
      
      ip_out(0, IP_PROTO_ICMP, txbuf, len);
      break;
  }
}
