#ifndef nbnsH
#define nbnsH

#include "platform.h"


struct nbns_header  {
  WORD name_trn_id;

  /* WORD */
  unsigned rd:1;
  unsigned tc:1;
  unsigned aa:1;
  unsigned opcode:4;
  unsigned qr:1;
  unsigned rcode:4;
  unsigned b:1;
  unsigned flags_reserved:2;
  unsigned ra:1;

  WORD qdcount;
  WORD ancount;
  WORD nscount;
  WORD arcount;
  BYTE tail[];
};

#define NBNS_OPCODE_QUERY 0


struct nbns_name_query_tag {
  WORD question_type;
  WORD question_class;
  /* query ends here, response specific below */
  DWORD ttl;
  WORD rdlength;
  /* specific for IP class below */
  WORD nb_flags;
  DWORD nb_addr[1];
};

#define QUERY_TAG_LEN 4 /* just the query, not the whole structure */

#define QUESTION_TYPE_NB 0x0020
#define QUESTION_CLASS_IN 0x0001


extern void nbns_start(void);


#endif
