#include "platform.h"

#include "timer.h"
#include "pwm.h"


void pwm_init(void)
{
  CCP1CON=0x0c; /* CCP configured as PWM */
  CCPR1L=0x00; /* duty cycle is 0 */
  T2CON=0x06; /* prescale by 16, timer on */
}


void sound(unsigned char period)
{
  TRISC&=~0x04; /* configure as output */
  PR2=period;
  CCPR1L=period/2;
}


void nosound(void)
{
  TRISC|=0x04; /* configure as input */
  CCPR1L=0x00;
}


void sound_ok(void)
{
  sound(TONE_A);
  delay(100);
  sound((unsigned char)(TONE_A*HALFTONE_4));
  delay(150);
  nosound();
}


void sound_failed(void)
{
  sound(TONE_A_LOW);
  delay(50);
  nosound();
  delay(75);
  sound(TONE_A_LOW);
  delay(50);
  nosound();
  delay(75);
  sound(TONE_A_LOW);
  delay(50);
  nosound();
}
