#ifndef udpH
#define udpH

#include "platform.h"
#include "ip.h"


/* UDP header structure */
struct udp_header {
  WORD sourceport;
  WORD destport;
  WORD length;
  WORD checksum;
  BYTE tail[];
};


/* minimal length of reserved buffer area when sending UDP datagram */
#define UDP_RESERVED (IP_RESERVED+sizeof(struct udp_header))


/* macro defining application callback function */
#define UDP_APP_HANDLER(x) void (x)(struct ip_header *iph, struct udp_header *udph, unsigned int len)

struct udp_socket {
  WORD port;
  UDP_APP_HANDLER(*app_handler);
};

#define UDP_SOCKETS 8
extern struct udp_socket udp_socket_tab[UDP_SOCKETS];


/* open/close a port for listening */
extern WORD udp_listen(WORD port, void *handler);
extern void udp_close_port(WORD port);


/* packet feed/transmission */
extern void udp_in(struct ip_header *iph, unsigned int len);
extern void udp_out(DWORD destip, WORD destport, WORD sourceport, unsigned int txbuf, unsigned int len);

#endif
